from distributions import *
from collections import defaultdict

def is_sched(ts_mcx, ps, debug = False, inflated = True):

    print "checking sched"
    ts_mcx.setScheme(ps)
    sched_val = True
    
    minAperiods = []
    mx_wss = {'B' : [],
              'C' : 0}
    for core in range(0, 4):
        if len(ts_mcx.level('A').core(core)) == 0:
            minAperiods.append(0)
        else:
            minAperiods.append(min([t.period for t in ts_mcx.level('A').core(core)]))
        if len(ts_mcx.level('B').core(core)) == 0:
            mx_wss['B'].append(0)
        else:
            mx_wss['B'].append(min([t.wss for t in ts_mcx.level('B').core(core)]))
            
    if len(ts_mcx.level('C')) != 0:
        mx_wss['C'] = min([t.wss for t in ts_mcx.level('C')])
    
    UA = defaultdict()
    UA['A'] = []
    UA['B'] = []
    UA['C'] = []
    for i in range(0, CORES):
        UA['A'].append(ts_mcx.level('A').core(i).utilization('A', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss))
        UA['B'].append(ts_mcx.level('A').core(i).utilization('B', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss))
        UA['C'].append(ts_mcx.level('A').core(i).utilization('C', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss))
    
    UA = ts_mcx.secondaryInflateConst(UA, minAperiods = minAperiods)
    UA = ts_mcx.secondaryInflateCPD(UA, minAperiods = minAperiods)
    
    
    for i in range(0, CORES):
        sched_val = sched_val and  UA['A'][i] <= 1
        
        tsH = ts_mcx.level('A')
        tsH.extend(ts_mcx.level('B'))
#         print "sched comp:", UA['B'][i] + ts_mcx.level('B').core(i).utilization('B', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss), tsH.core(i).utilization('B', approximate = True, inflated = True, c_taskset = ts_mcx.C, minAperiods = minAperiods, mx_wss = mx_wss)
        sched_val = sched_val and (UA['B'][i]
                                 + ts_mcx.level('B').core(i).utilization('B', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss)) <= 1
    
    # -----C first sched condition
    sched_val = sched_val and (sum(UA['C'])
                             + ts_mcx.level('B').utilization('C', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss) 
                             + ts_mcx.level('C').utilization('C', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss)) <= CORES
    
    # -----C second sched condition
    
    h = ts_mcx.level('C').max_utilization('C', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss)
    H = ts_mcx.level('C').utilization('C', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss, heaviest = CORES-1)
    
    sched_val = sched_val and (sum(UA['C'])
                             + ts_mcx.level('B').utilization('C', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss) + 3*h+H) < 4
    
    if debug:
        # print "Sched check values: "
#         for i in range(0, CORES):
#             print "  Core " + str(i)
#             print "    AA: " + str(UA['A'][i])
#             print "    AB: " + str(UA['B'][i])
# #             print "    AB: " + str(ts_mcx.level('A').core(i).utilization('B', approximate = False, inflated = True, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods))
#             print "    AC: " + str(UA['C'][i])
#             
#             print "    BB: " + str(ts_mcx.level('B').core(i).utilization('B', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss))
#             print "    BC: " + str(ts_mcx.level('B').core(i).utilization('C', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss))
#         print "  CC: " + str(ts_mcx.level('C').utilization('C', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss))
#         print "  h: " + str(ts_mcx.level('C').max_utilization('C', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss))
#         print "  H: " + str(ts_mcx.level('C').utilization('C', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss, heaviest = CORES-1))

        U = dict()
        U['A'] = 0
        U['B'] = 0
        
        for i in range(0, CORES):
#             print "  Core " + str(i)
            U['A'] = max(U['A'], UA['A'][i])
            U['B'] = max(U['B'], UA['B'][i] + ts_mcx.level('B').core(i).utilization('B', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss))
            # print "    Asched: " + str(UA['A'][i])
#             print "    Bsched: " + str(UA['B'][i] + ts_mcx.level('B').core(i).utilization('B', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss))
        
        AC = sum(UA['C'])
        BC = ts_mcx.level('B').utilization('C', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss)
        # print "  Csched: " + str(AC
#                                 +BC
#                                 +ts_mcx.level('C').utilization('C', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss))
        
        U['C'] = (AC
                +BC
                +ts_mcx.level('C').utilization('C', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss))
                
        U['H'] = (AC+BC
                +3*ts_mcx.level('C').max_utilization('C', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss)
                +ts_mcx.level('C').utilization('C', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss, heaviest = CORES-1))
        
        U['S'] = len(ts_mcx)
        if sched_val:
            return U
        else:
            return None
                                 
        # print "  Hsched: " + str(AC+BC
#                                  +3*(ts_mcx.level('C').max_utilization('C', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss))
#                                  +   ts_mcx.level('C').utilization('C', approximate = False, inflated = inflated, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, mx_wss = mx_wss, heaviest = CORES-1))

        
#         print ""
#         print "Actual values: "
#         for i in range(0, CORES):
#             print "  Core " + str(i)
#             print "    AA: " + str(ts_mcx.level('A').core(i).utilization('A', approximate = True, inflated = True, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods))
#             print "    AB: " + str(ts_mcx.level('A').core(i).utilization('B', approximate = True, inflated = True, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods))
#             print "    AC: " + str(ts_mcx.level('A').core(i).utilization('C', approximate = True, inflated = True, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods))
#             print "    BB: " + str(ts_mcx.level('B').core(i).utilization('B', approximate = True, inflated = True, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods))
#             print "    BC: " + str(ts_mcx.level('B').core(i).utilization('C', approximate = True, inflated = True, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods))
#         print "  CC: " + str(ts_mcx.level('C').utilization('C', approximate = True, inflated = True, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods))
#         print "  h: " + str(ts_mcx.level('C').max_utilization('C', approximate = True, inflated = True, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods))
#         print "  H: " + str(ts_mcx.level('C').utilization('C', approximate = True, inflated = True, c_taskset = ts_mcx.level('C'), minAperiods = minAperiods, heaviest = CORES-1))
        
    return sched_val